libname B_W "D:\Olivier\Universit\U-Enseignement\Elves ENS\analyseText";


data a; set b_w.baudgoll;
length csdet $10;
if (quest="3" or CS="81") then csdet="Chmeurs";
else if (quest="5" or "70"<CS<"80" or CS="86") then csdet="Retrats";
*else if (quest="4" or CS="85") then csdet="Inactives";
else if cs="10" then csdet="Agriculteurs";
else if cs IN ("21") then csdet="Artisans";
*else if cs IN ("22") then csdet="Commerants";
else if cs IN ("22","23") then csdet="Patrons";
else if cs IN ("31","35") then csdet="ProfLib";
else if cs IN ("33","37","38") then csdet="CadSup";
else if cs IN ("34") then csdet="Professeurs";
*else if cs IN ("35") then csdet="InfoSpec";
*else if cs IN ("37") then csdet="CadresPri";
*else if cs IN ("38") then csdet="Ingnieurs";
else if cs IN ("42") then csdet="Instits";
else if cs IN ("43","44") then csdet="Infirmires";
else if cs IN ("45") then csdet="PI_Pub";
else if cs IN ("46") then csdet="PI_Pri";
else if cs IN ("47") then csdet="Techniciens";
else if cs IN ("48") then csdet="Contremaitres";
else if cs IN ("52") then csdet="Flics";
else if cs IN ("53") then csdet="Emp. Pub";
else if cs IN ("54") then csdet="Emp. Adm";
else if cs IN ("55") then csdet="Emp. Com";
else if cs IN ("56") then csdet="Emp. Part";
else if cs IN ("62","63","64","65") then csdet="Ouv. Qual.";
else if cs IN ("67","68","69") then csdet="ONQ";
else csdet=cs;
run;

********************************************
- Premire mthode en slectionnant 
les mots de taille suprieure  2 caractres
et prsents plus de 25 fois dans la base
********************************************
;

%Anatext
(where=QUEST NE "5", keep=CSDET, var=heureu1 heureu2
heureu3,traitem=1,data=A,recol=OUI,minlong=2,minfreq=24,Majuscul=OUI,Accents=OUI,Ecran=Oui,mat=0,
anafac=0,indiv=1,motoutil=NON,basoutil=B_W.MOTOUTIL);

proc sort data=_HEURE1_ ;by mot; run;
proc sort data=_HEURE2_ ;by mot; run;

proc print data=b; where segme2="S ENTENDRE"; run;

data B; merge _HEURE1_ _HEURE2_;
by mot;
if SEGME2 = "S ENTENDRE"  or SEGME2="LE TRAVAIL" or SEGME2="DU TRAVAIL" or SEGME2="UN TRAVAIL" then LISTE=SEGME2;
else LISTE=MOT; 
if LISTE="UN TRAVAIL" then LISTE="DU TRAVAIL";
if LISTE="S ENTENDRE" then LISTE="S'ENTENDRE";
if LISTE="TRAVAIL" then LISTE="";
if LISTE="ENTENDRE" then LISTE="";
run;

proc corresp data=B outc=sor; 
tables CSDET, liste; 
where freqform>24 and longueur>2 and CSDET NOT IN ("82","83","84","99");
run;
options ps=120 ls=160;
proc plot data=sor;
plot dim2*dim1$_NAME_/HREF=0 VREF=0;
run;



********************************************
- Deuxime mthode en cherchant une liste 
dfinie de mots et d'expressions, ici les 
49 mots visibles
dans l'article. En regardant s'ils sont 
prsents ou absents.
********************************************
;

%VDmot (datainit=a,dataout=c,var=heureu1 heureu2
heureu3,Prefvar=FG,iff= HEUREU1 NE "",
mots=
ACTIVITE*. FINANCIERS. REVENUS. HARMONIE.
PEAU. FAMILIALE. TRANQUILITE. LIBERTE. PROFESSION. REUSSITE. ETRE. TEMPS LIBRE. ENVIE. AMITIE. POUVOIR. 
FAMILLE. EQUILIBRES. SECURITE. UNIE. AMOUR. METIER. AIMER. SENTIR. LOISIRS. AMIS. AIME. FAIRE. SOI. ENFANT. 
EMPLOI. TRAVAILLER. STABLE. FOYER. LOGEMENT. AVOIR. LE TRAVAIL. DU TRAVAIL=UN TRAVAIL. BOULOT. SALAIRE. MAISON. ARGENT. 
MALADE. COUPLE. MENAGE. SANTE. TOIT. ENFANTS. PROFITER. MARI.,Recol=OUI,Majuscul=OUI,Accents=OUI,Ecran=Oui,anafac=NON);

proc means sum data=c noprint; 
var fg1-fg49 ;
class csdet; 
output out=d; 
Where QUEST NE "5"
run;

proc corresp data=d outc=sor2 dim=2 ; 
VAR FG1-FG49;
id CSDET;
WEIGHT _FREQ_;
where _type_=1 and _stat_="MEAN" and CSDET NOT IN ("99","84","83");
RUN;

options ps=80 ls=160;
proc plot data=sor2;
plot dim2*dim1$CSDET/HREF=0 VREF=0;
run;


****************************
Pour reproduire les tableaux
croiss

**************************;

%VDmot (datainit=a,dataout=e,var=heureu1 heureu2
heureu3,Prefvar=FG,iff= HEUREU1 NE "",
mots=
TRAVAIL*. EMPLOI*. BOULOT*. PROFESSION*=METIER*.
TRAVAIL*=BOULOT*=EMPLOI*=METIER*=PROFESSION*. 
LE TRAVAIL. DU TRAVAIL.
AVOIR. ETRE.,Recol=OUI,Majuscul=OUI,Accents=OUI,Ecran=Oui,anafac=NON);

proc freq data=e; tables (sexe quest)*(FG1-FG5) / chisq; 
format FG1 FG1_.
FG2 FG2_.
FG3 FG3_.
FG4 FG4_.
FG5 FG5_.
; run;













